﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Cv1
{
    public class Stack<TData> : IEnumerable<TData>
    {

        public delegate void CallbackType(TData value);

        public event CallbackType OnPush;
        public event CallbackType OnPop;


        private TData[] data = new TData[10];

        private int top = 0;
        

        public TData Top { 
            get {
                if (top == 0) {
                    throw new StackException();
                }
                return this.data[top - 1];
            }
        }
        
        public void Push(TData value)
        {
            if (OnPush != null)
            {
                OnPush(value);
            }

            this.data[top] = value;
            top++;
        }

        public TData Pop() {
            top--;
            if (OnPop != null) {
                OnPop(this.data[top]);
            }
            return this.data[top];
        }



        public IEnumerator<TData> GetEnumerator()
        {
            for (int i = this.top - 1; i >= 0; i--)
            {
                yield return this.data[i];
            }
            //return new MyStackEnumerator<TData>(this.data, this.top);
        }

        IEnumerator IEnumerable.GetEnumerator()
        {
            for (int i = this.top - 1; i >= 0; i--) {
                yield return this.data[i];
            }
            //return new MyStackEnumerator<TData>(this.data, this.top);
        }

    }
}
